/** @file ptrn_noise_cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.2
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef PTRN_NOISE_CMDLINE_H
#define PTRN_NOISE_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef PTRN_NOISE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define PTRN_NOISE_PARSER_PACKAGE "noise-bench"
#endif

#ifndef PTRN_NOISE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define PTRN_NOISE_PARSER_PACKAGE_NAME "noise-bench"
#endif

#ifndef PTRN_NOISE_PARSER_VERSION
/** @brief the program version */
#define PTRN_NOISE_PARSER_VERSION "0.1"
#endif

/** @brief Where the command line options are stored */
struct ptrn_noise_cmd_struct
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *pattern_help; /**< @brief Pattern argument help description.  */
  char * method_arg;	/**< @brief Selects the benchmark to use (default='selfish').  */
  char * method_orig;	/**< @brief Selects the benchmark to use original value given at command line.  */
  const char *method_help; /**< @brief Selects the benchmark to use help description.  */
  int samples_arg;	/**< @brief Number of samples the benchmark should obtain (default='100000').  */
  char * samples_orig;	/**< @brief Number of samples the benchmark should obtain original value given at command line.  */
  const char *samples_help; /**< @brief Number of samples the benchmark should obtain help description.  */
  int duration_arg;	/**< @brief Ideal duration of computation phase in microseconds (default='1000').  */
  char * duration_orig;	/**< @brief Ideal duration of computation phase in microseconds original value given at command line.  */
  const char *duration_help; /**< @brief Ideal duration of computation phase in microseconds help description.  */
  int threshold_arg;	/**< @brief Threshold value which governs how long a detour cycle has to be (in per cent of the minimal cycle length) to be recorded by the detour-benchmark (default='900').  */
  char * threshold_orig;	/**< @brief Threshold value which governs how long a detour cycle has to be (in per cent of the minimal cycle length) to be recorded by the detour-benchmark original value given at command line.  */
  const char *threshold_help; /**< @brief Threshold value which governs how long a detour cycle has to be (in per cent of the minimal cycle length) to be recorded by the detour-benchmark help description.  */
  int write_all_flag;	/**< @brief Each rank writes the trace file (default=off).  */
  const char *write_all_help; /**< @brief Each rank writes the trace file help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int pattern_given ;	/**< @brief Whether pattern was given.  */
  unsigned int method_given ;	/**< @brief Whether method was given.  */
  unsigned int samples_given ;	/**< @brief Whether samples was given.  */
  unsigned int duration_given ;	/**< @brief Whether duration was given.  */
  unsigned int threshold_given ;	/**< @brief Whether threshold was given.  */
  unsigned int write_all_given ;	/**< @brief Whether write-all was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct ptrn_noise_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure ptrn_noise_cmd_struct (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure ptrn_noise_cmd_struct (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *ptrn_noise_cmd_struct_purpose;
/** @brief the usage string of the program */
extern const char *ptrn_noise_cmd_struct_usage;
/** @brief all the lines making the help output */
extern const char *ptrn_noise_cmd_struct_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int ptrn_noise_parser (int argc, char * const *argv,
  struct ptrn_noise_cmd_struct *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use ptrn_noise_parser_ext() instead
 */
int ptrn_noise_parser2 (int argc, char * const *argv,
  struct ptrn_noise_cmd_struct *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int ptrn_noise_parser_ext (int argc, char * const *argv,
  struct ptrn_noise_cmd_struct *args_info,
  struct ptrn_noise_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int ptrn_noise_parser_dump(FILE *outfile,
  struct ptrn_noise_cmd_struct *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int ptrn_noise_parser_file_save(const char *filename,
  struct ptrn_noise_cmd_struct *args_info);

/**
 * Print the help
 */
void ptrn_noise_parser_print_help(void);
/**
 * Print the version
 */
void ptrn_noise_parser_print_version(void);

/**
 * Initializes all the fields a ptrn_noise_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void ptrn_noise_parser_params_init(struct ptrn_noise_parser_params *params);

/**
 * Allocates dynamically a ptrn_noise_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized ptrn_noise_parser_params structure
 */
struct ptrn_noise_parser_params *ptrn_noise_parser_params_create(void);

/**
 * Initializes the passed ptrn_noise_cmd_struct structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void ptrn_noise_parser_init (struct ptrn_noise_cmd_struct *args_info);
/**
 * Deallocates the string fields of the ptrn_noise_cmd_struct structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void ptrn_noise_parser_free (struct ptrn_noise_cmd_struct *args_info);

/**
 * The string parser (interprets the passed string as a command line)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int ptrn_noise_parser_string (const char *cmdline, struct ptrn_noise_cmd_struct *args_info,
  const char *prog_name);
/**
 * The string parser (version with additional parameters - deprecated)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use ptrn_noise_parser_string_ext() instead
 */
int ptrn_noise_parser_string2 (const char *cmdline, struct ptrn_noise_cmd_struct *args_info,
  const char *prog_name,
  int override, int initialize, int check_required);
/**
 * The string parser (version with additional parameters)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int ptrn_noise_parser_string_ext (const char *cmdline, struct ptrn_noise_cmd_struct *args_info,
  const char *prog_name,
  struct ptrn_noise_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int ptrn_noise_parser_required (struct ptrn_noise_cmd_struct *args_info,
  const char *prog_name);

extern const char *ptrn_noise_parser_method_values[];  /**< @brief Possible values for method. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* PTRN_NOISE_CMDLINE_H */
